#include "mex.h"
#include <math.h>
#include <omp.h>
/*Function written by Michael Croucher*/
void spawn_threads(double bm[],double xm[],double nu,int rows, int cols,double result[])
{
	int countmax = rows*cols;
    int count=0;
    int rowcount,colcount;
	for(colcount = 0;colcount<cols;colcount++)
        {
        for(rowcount = 0;rowcount<rows;rowcount++)
          { 
            result[count] = bm[colcount] * pow( (xm[rowcount]/2) , (2*colcount+nu) );
            count++;
          }
	}

}

void mexFunction(int nlhs,mxArray* plhs[], int nrhs, const mxArray* prhs[])
{

	/*The original MATLAB call was/*
	/*sumfact=bm.*(xm./2).^(2.*sumfact_repmat+nu);/*

	/*Find number of rows and columns in input data*/
	int bmrows = mxGetM(prhs[0]);
	int bmcols = mxGetN(prhs[0]);

	int xmrows = mxGetM(prhs[1]);
	int xmcols = mxGetN(prhs[1]);
		

	/*Get pointers to input data*/
	double* bm = mxGetPr(prhs[0]);
	double* xm = mxGetPr(prhs[1]);
    double* nu = mxGetPr(prhs[2]);
	double nuval = nu[0];
   
   /*create space for output*/
 	 plhs[0] = mxCreateDoubleMatrix(xmrows,bmcols, mxREAL);

	/*Get pointer to output array*/
	double* result = mxGetPr(plhs[0]);
    
	/*Do the calculation*/
	spawn_threads(bm,xm,nuval,xmrows,bmcols,result);
}
