function f=bm(nu,n)

%this computes the bm factor from Li, Li and Gross, 2006, app. math. and
%computation (equation 13, the expression for \hat{b}). 
%Input is nu (the bessel order) and n (an order of approximation). 
%The output is a series of bm values corresponding to
%m-values ranging from 0..n
%using factorial and double factorial functions from %Paul Godfrey
%(downloaded from matlab central

m=0:1:n;
   f1=(-1).^m;
   f2=fact(n+m-1)./(fact(m).*fact(n-m));
   f3=n.^(1-2.*m)./gamma_god(nu+m+1);
   f=f1.*f2.*f3;